mod Ex06a

incl Mtex

loc rem 
  \para \bf  6. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 21.3.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie pomocnych funkcii 
         a predikatov. 
   \item \para Subor(y) \it  ex06*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Combinatorial Functions over Lists.  \end 

rem 
  \para \bf  Suffix relation.  \end 

pred/2 Suffix 'Tex2_sqsupset'
  Suffix(x,y) <-> \e z x = z++y

rem 
  \para We have 
  \eq* 
    Suffix(0,y) <-> y = 0
  \end
  \eq* 
    Suffix((v,w),y) <-> y = v,w \/ Suffix(w,y)
  \end

rem 
  \para \bf  Generating suffixes.  \end Define the function \ft Suffixes(x) \end 
  such that 
  \eq* 
    y in Suffixes(x) <-> Suffix(x,y)
  \end

fun Suffixes 
  Suffixes(x) = Foo

rem 
  \para \bf  Auxiliary function.  \end \header* fun/2 Mape  \end Define the 
  function \ft Mape(y,x) \end such that 
  \eq* 
    z in Mape(y,x) <-> \e z1(z1 in x & z = y,z1)
  \end

fun/2 Mape 
  Mape(y,x) = Foo

rem 
  \para \bf  Prefix relation.  \end 

pred/2 Prefix 'Tex2_sqsubset'
  Prefix(y,x) <-> \e z x = y++z

rem 
  \para We have 
  \eq* 
    Prefix(y,0) <-> y = 0
  \end
  \eq* 
    Prefix(y,v,w) <-> y = 0 \/ \e z(Prefix(z,w) & y = v,z)
  \end

rem 
  \para \bf  Generating prefixes.  \end Define the function \ft Prefixes(x) \end 
  such that 
  \eq* 
    y in Prefixes(x) <-> Prefix(y,x)
  \end

fun Prefixes 
  Prefixes(x) = Foo

rem 
  \para \bf  Segments.  \end 

pred/2 Segment 'Tex2_subset'
  Segment(y,x) <-> \e z1\e z2 x = z1++y++z2

rem 
  \para We have 
  \eq* 
    Segment(y,0) <-> y = 0
  \end
  \eq* 
    Segment(y,v,w) <-> \e z(Prefix(z,w) & y = v,z) \/ Segment(y,w)
  \end

rem 
  \para \bf  Generating segments.  \end Define the function \ft Segments(x) \end 
  such that 
  \eq* 
    y in Segments(x) <-> Segment(y,x)
  \end

fun Segments 
  Segments(x) = Foo

rem 
  \para \bf  Subsequences.  \end 

pred/2 Subsq 'Tex2_triangleleft'
  Subsq(y,0) <- y = 0
  Subsq(y,v1,w1) <- y = 0
  Subsq(y,v1,w1) <- y = v2,w2 & v2 = v1 & Subsq(w2,w1)
  Subsq(y,v1,w1) <- y = v2,w2 & v2 != v1 & Subsq(y,w1)

rem 
  \para We have 
  \eq* 
    Subsq(y,0) <-> y = 0
  \end
  \eq* 
    Subsq(y,v,w) <-> \e z(y = v,z & Subsq(z,w)) \/ Subsq(y,w)
  \end

rem 
  \para \bf  Generating subsequences.  \end Define the function 
  \ft Subsqs(x) \end such that 
  \eq* 
    y in Subsqs(x) <-> Subsq(y,x)
  \end

fun Subsqs 
  Subsqs(x) = Foo

rem 
  \para \bf  Permutations.  \end 

fun/2 Count 'Tex_f2_ln_count'
  Count(a,0) = 0
  Count(a,v,w) = Count(a,w)+1 <- a = v
  Count(a,v,w) = Count(a,w) <- a != v

pred/2 Perm 'Tex2_sim'
  Perm(x,y) <-> \a a Count(a,x) = Count(a,y)

rem 
  \para \header* pred/3 Inserted 'Tex_p3_ln_inserted' \end We have 
  \eq* 
    Perm(y,0) <-> y = 0
  \end
  \eq* 
    Perm(y,v,w) <-> \e z(Perm(z,w) & Inserted(y,z,v))
  \end
  \para where 
  \eq* 
    Inserted(y,x,a) <-> \e z1\e z2(x = z1++z2 & y = z1++(a,z2))
  \end

rem 
  \para \bf  Generating permutations.  \end Define the function 
  \ft Perms(x) \end such that 
  \eq* 
    y in Perms(x) <-> Perm(y,x)
  \end

fun Perms 
  Perms(x) = Foo

rem 
  \para \bf  List partitions.  \end 

fun Union 'Tex_f1_ln_union'
  Union(0) = 0
  Union(v,w) = v++Union(w)

pred/2 Concp 'Tex_p2_ln_concp'
  Concp(y,x) <-> Union(y) = x & 0 !in y

rem 
  \para We have 
  \eq* 
    Concp(y,0) <-> y = 0
  \end
  \eq* 
    Concp(y,v,w) <-> 
    \e z(Concp(z,w) & y = (v,0),z) \/ 
    \e z1\e z2(Concp((z1,z2),w) & y = (v,z1),z2)
  \end

rem 
  \para \bf  Generating list partitions.  \end Define the function 
  \ft Concps(x) \end such that 
  \eq* 
    y in Concps(x) <-> Concp(y,x)
  \end

fun Concps 
  Concps(x) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc rem 
  \para \bf  [CL] ASCII characters.  \end Every character in the extended ASCII 
  set has assigned a value \ft n < 256 \end. For instance the denotation of the 
  character \ft "a" \end is the number \ft 97 \end, ie we have 
  \eq* 
    "a" = 97
  \end
  \para Use the format \ft Ch \end to display numbers as characters, e.g. the 
  result of the simple query 
  \verbatim 
      97 = c:Ch
  \end
  \para is shown as the character \ft "a" \end. Note that the predicate 
  \ft Ch \end is defined in the module \ft Standard \end. Note also that 
  characters are enclosed in double quotes. 

loc rem 
  \para \bf  [CL] ASCII strings.  \end A finite sequence of extended ASCII 
  characters is called a string. For instance, the string \ft 'abcd' \end 
  denotes the same number as does the sequence \ft "a","b","c","d",0 \end, ie we 
  have 
  \eq* 
    'abcd' = "a","b","c","d",0
  \end
  \para Use the format \ft Str \end to display numbers as strings, e.g. the 
  result of the simple query 
  \verbatim 
      97,98,99,100,0 = s:Str
  \end
  \para is shown as the string constant \ft 'abcd' \end. Note that the predicate 
  \ft Str \end is defined in the module \ft Standard \end. Note also that string 
  constants are enclosed in single quotes. 

rem 
  \para \bf  [CL] Formatting the output.  \end Use the predicate \ft Ls \end as 
  a format to display numbers as lists of strings. Try out next queries 
  \verbatim 
      (97,98,99,100,0),(101,102,103,0),(104,105,0),0 = x:Ls
  \end
  \para and 
  \verbatim 
      Suffixes('abcd') = x:Ls
  \end

pred Ls 
  Ls(0)
  Ls(v,w) <- Str(v) & Ls(w)

