mod Ex06c

incl Mtex

incl Maux

loc rem 
  \para \bf  6. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 21.3.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie pomocnych funkcii 
         a predikatov. 
   \item \para Subor(y) \it  ex06*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Applications of Lists.  \end 

rem 
  \para \bf  Subsection. Finite Sets.  \end 

rem 
  \para \bf  Definition.  \end 

pred Set 
  Set(s) <-> \a i\a j(i < j & j < L(s) -> Sub(s,i) < Sub(s,j))

rem 
  \para \bf  Set membership.  \end 
  \header* pred/2 Member 'Tex_p2_set_member' \end Define the predicate 
  \ft Member(a,s) \end such that 
  \eq* 
    Set(s) -> Member(a,s) <-> a in s
  \end

pred/2 Member 'Tex_p2_set_member'
  Member(a,s) <-> Poo

rem 
  \para \bf  Insertion.  \end \header* fun/2 Insert 'Tex_f2_set_insert' \end 
  Define the function \ft Insert(s,a) \end such that 
  \eq* 
    Set(s) -> b in Insert(s,a) <-> b = a \/ b in s
  \end
  \eq* 
    Set(s) -> Set Insert(s,a)
  \end

fun/2 Insert 'Tex_f2_set_insert'
  Insert(s,a) = Foo

rem 
  \para \bf  Deletion.  \end \header* fun/2 Delete 'Tex_f2_set_delete' \end 
  Define the function \ft Delete(s,a) \end such that 
  \eq* 
    Set(s) -> b in Delete(s,a) <-> b in s & b != a
  \end
  \eq* 
    Set(s) -> Set Delete(s,a)
  \end

fun/2 Delete 'Tex_f2_set_delete'
  Delete(s,a) = Foo

rem 
  \para \bf  Union.  \end \header* fun/2 Union 'Tex_f2_set_union' \end Define 
  the function \ft Union(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Union(s1,s2) <-> a in s1 \/ a in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Union(s1,s2)
  \end

fun/2 Union 'Tex_f2_set_union'
  Union(s1,s2) = Foo

rem 
  \para \bf  Intersection.  \end \header* fun/2 Inter 'Tex_f2_set_inter' \end 
  Define the function \ft Inter(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Inter(s1,s2) <-> a in s1 & a in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Inter(s1,s2)
  \end

fun/2 Inter 'Tex_f2_set_inter'
  Inter(s1,s2) = Foo

rem 
  \para \bf  Difference.  \end \header* fun/2 Diff 'Tex_f2_set_diff' \end Define 
  the function \ft Diff(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Diff(s1,s2) <-> a in s1 & a !in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Diff(s1,s2)
  \end

fun/2 Diff 'Tex_f2_set_diff'
  Diff(s1,s2) = Foo

rem 
  \para \bf  Symmetric difference.  \end 
  \header* fun/2 Sdiff 'Tex_f2_set_sdiff' \end Define the function 
  \ft Sdiff(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Sdiff(s1,s2) <-> 
    a in s1 & a !in s2 \/ a !in s1 & a in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Sdiff(s1,s2)
  \end

fun/2 Sdiff 'Tex_f2_set_sdiff'
  Sdiff(s1,s2) = Foo

rem 
  \para \bf  Set equality.  \end \header* pred/2 Eqset 'Tex_p2_set_eqset' \end 
  Define the predicate \ft Eqset(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> Eqset(s1,s2) <-> \a a(a in s1 <-> a in s2)
  \end

pred/2 Eqset 'Tex_p2_set_eqset'
  Eqset(s1,s2) <-> Poo

rem 
  \para \bf  Subsets.  \end \header* pred/2 Subset 'Tex_p2_set_subset' \end 
  Define the predicate \ft Subset(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> Subset(s1,s2) <-> \a a(a in s1 -> a in s2)
  \end

pred/2 Subset 'Tex_p2_set_subset'
  Subset(s1,s2) <-> Poo

